%%% ====================================================================
%%%  @@C-Web-file{
%%%     author          = "Andreas Scherer",
%%%     version         = "0.03",
%%%     date            = "24 August 2001",
%%%     time            = "18:37:09 MDT",
%%%     filename        = "polynom.ch",
%%%     address         = "Abt-Wolf-Stra{\ss}e 17
%%%                        96215 Lichtenfels
%%%                        Germany
%%%                        Tel: [++49] (0) 9571 / 2013",
%%%     checksum        = "43562 275 883 8176",
%%%     codetable       = "ISO/ASCII",
%%%     keywords        = "checksum"
%%%     supported       = "yes",
%%%     docstring       = "The checksum field above contains a CRC-16
%%%                        checksum as the first value, followed by the
%%%                        equivalent of the standard UNIX wc (word
%%%                        count) utility output of lines, words, and
%%%                        characters.  This is produced by checksum
%%%                        itself.",
%%%  }
%%% ====================================================================

%%% Revision history (reverse time order):
%%%
%%% 0.3 [24-Aug-2001] Nelson H. F. Beebe, University of Utah
%%%     Update for use with cwebxmac.tex, and add code to define
%%%     EXIT_FAILURE and EXIT_SUCCESS in case these are undefined.
%%%
%%% 0.2 [06-May-1994] Nelson H. F. Beebe, University of Utah
%%%     Remove assignment from one if () expression to remove compiler
%%%     warnings.
%%%
%%% 0.1 [15-Mar-1994]
%%%     Memory allocation failure should result in `exit(1)'.
%%%
%%% 0.0 [14-Mar-1994]
%%%     Modifications for use on AMIGA.
%%%
%%% ====================================================================

------------------------------------------------------------------------
@x l.1
@* Polynomial program.
@y
\nocon
\let\mc=\ninerm % medium caps
\def\CEE/{{\mc C\spacefactor1000}}
\def\readsections{\input \jobname.scn}
\def\fin{\par\vfill\eject
  \message{Section names:}
  \def\note##1##2.{\quad{\eightrm##1~##2.}}
  \def\Q{\note{Cited in section}}
  \def\Qs{\note{Cited in sections}}
  \def\U{\note{Used in section}}
  \def\Us{\note{Used in sections}}
  \def\I{\par\hangindent 2em}
  \def\@@{\par\hangindent 2em}
  \let\*=*
  \readsections}
\let\PB=\relax % hook for program brackets |...| in TeX part or section name
\def\X#1:#2\X{{\relax\hbox{$\langle\,${#2\eightrm\enspace#1}$\,\rangle$}\relax}} % module name
@* Polynomial program.
@z
------------------------------------------------------------------------
@x l.32
typedef Field LongPoly[SIZE+SIZE];
@
@<Global constants@>=
unsigned int	CRC_INT = 0x8005;
@
@<Global variables@>=
@y
typedef Field LongPoly[SIZE+SIZE];
@ @<Global constants@>=
unsigned int	CRC_INT = 0x8005;
@ @<Global variables@>=
@z
------------------------------------------------------------------------
@x l.40
other standard header files.  Until all C implementations reach
the level of the 1989 ANSI C standard, we have to be careful about
which files we try to include.  The GNU C compiler defines the
@y
other standard header files.  Until all \CEE/ implementations reach
the level of the 1989 {\mc ANSI C} standard, we have to be careful about
which files we try to include.  The {\mc GNU C} compiler defines the
@z
------------------------------------------------------------------------
@x l.47 [NHFB] -- add C++ support
#if defined(__STDC__) && !defined(__GNUC__)
@y
#if defined(__STDC__) || defined(__GNUC__) || defined(__TURBOC__) || \
    defined(MSDOS) || defined(__cplusplus) || defined(c_plusplus)
#define STDC 1
#else
#define STDC 0
#endif

#if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
@z
------------------------------------------------------------------------
@x l.53 [NHFB] -- define EXIT_xxx in case <stdlib.h> was not included, or failed to do so
#ifdef THINK_C
@y
#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#endif
#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif

#ifdef THINK_C
@z
------------------------------------------------------------------------
@x l.63
void ConvertIntToPoly ARGS((unsigned int Int,polyPtr Ptr));
Field FPlus ARGS((Field s,Field t));
int main ARGS((void));
void ReduceLongPoly ARGS((LongPoly *s, Poly *t, Poly *u));
unsigned int ReductionOfByte ARGS((unsigned int x));
@y
void ConvertIntToPoly ARGS((unsigned int Int,polyPtr Ptr));@/
Field FPlus ARGS((Field s,Field t));@/
int main ARGS((void));@/
void ReduceLongPoly ARGS((LongPoly *s, Poly *t, Poly *u));@/
unsigned int ReductionOfByte ARGS((unsigned int x));
@z
------------------------------------------------------------------------
@x l.72 [NHFB] -- C++ support
Field FPlus(s,t)
	Field s,t;
@y
#if STDC
Field FPlus(Field s, Field t)
#else
Field FPlus(s,t)
	Field s,t;
#endif
@z
------------------------------------------------------------------------
@x l.86
result in the place indicated by the pointer |u|.
@y
result in the place indicated by the pointer~|u|.
@z
------------------------------------------------------------------------
@x l.87 [NHFB] -- C++ support
void ReduceLongPoly(s,t,u)
	LongPoly *s;
	Poly *t, *u;
@y
#if STDC
void ReduceLongPoly(LongPoly *s, Poly *t, Poly *u)
#else
void ReduceLongPoly(s,t,u)
	LongPoly *s;
	Poly *t, *u;
#endif
@z
------------------------------------------------------------------------
@x l.108 [NHFB] -- C++ support
void ConvertIntToPoly(Int,Ptr)
	unsigned int Int;
	polyPtr Ptr;
@y
#if STDC
void ConvertIntToPoly(unsigned int Int, polyPtr Ptr)
#else
void ConvertIntToPoly(Int,Ptr)
	unsigned int Int;
	polyPtr Ptr;
#endif
@z
------------------------------------------------------------------------
@x l.128  [NHFB] -- C++ support
unsigned int ReductionOfByte(x)
	unsigned int x;
@y
#if STDC
unsigned int ReductionOfByte(unsigned int x)
#else
unsigned int ReductionOfByte(x)
	unsigned int x;
#endif
@z
------------------------------------------------------------------------
@x l.136
	@<Assign space for the structures that our pointers point to@>@/
@y
	@<Assign space for the structures that our pointers point to@>@;
@z
------------------------------------------------------------------------
@x l.148
@
@<Assign space...@>=
@y
@ @<Assign space...@>=
@z
------------------------------------------------------------------------
@x l.152
if ( (pt == NULL) || (pls == NULL))@/
@<Complain about malloc@>@/
@
@<Complain about malloc@>=
fprintf(stderr, "Trouble assigning space to pointers.\n");
@y
if ( (pt == NULL) || (pls == NULL))
@<Complain about malloc@>@;
@ @<Complain about malloc@>={
  fprintf(stderr, "Trouble assigning space to pointers.\n"); exit(1);
}
@z
------------------------------------------------------------------------
@x l.159 [NHFB] -- add C++ support
int
main ()
@y
#if STDC
int
main (void)
#else
int
main ()
#endif
@z
------------------------------------------------------------------------
@x l.162 [AS], plus [NHFB] -- remove assignment expression from if(), use EXIT_xxx
	@<Variables local to |main|@>@/
	@<Initialize Data Structures@>@/
	output_file = fopen("crc.tab","w");
	for(i=0;i < 32;i++)
	{for(j=0;j < 8; j++)
	fprintf(output_file,"0x%04x, ", ReductionOfByte(8*i + j));
	fprintf(output_file,"\n");}
	fclose(output_file);
	exit(0);
	return(0);
@y
	@<Variables local to |main|@>@;
	@<Initialize Data Structures@>@;
	output_file = fopen("crc.tab","w");
	if(output_file) {
	  for(i=0;i < 32;i++)
	  {for(j=0;j < 8; j++)
	  fprintf(output_file,"0x%04x, ", ReductionOfByte(8*i + j));
	  fprintf(output_file,"\n");}
	  fclose(output_file);
	  return(EXIT_SUCCESS);
	}
	else return(EXIT_FAILURE);
@z
------------------------------------------------------------------------
@x l.173
@
@<Variables local to...@>=
FILE *output_file;
unsigned int i, j;
@
@<Initialize Data Structures@>=
CRC_Ptr = (Poly *) malloc(sizeof(Poly));
if(CRC_Ptr == NULL)@<Complain about malloc@>@/
ConvertIntToPoly(CRC_INT,CRC_Ptr);
@y
@ @<Variables local to...@>=
FILE *output_file;
unsigned int i, j;
@ @<Initialize Data Structures@>=
CRC_Ptr = (Poly *) malloc(sizeof(Poly));
if(CRC_Ptr == NULL)@<Complain about malloc@>@;
ConvertIntToPoly(CRC_INT,CRC_Ptr);
@* Index and section names.
@z
------------------------------------------------------------------------
